package pjvukol;

/* mensi hint :-) */
import java.util.ListIterator;
import java.util.LinkedList;


/**
 * Reprezentuje slozeny interval, tj. mnozinu jednoduchych intervalu.
 * Prvni interval se vlozi konstruktorem, dalsi pak pomoci metody pridej.
 *
 * V lehci variante postaci, pokud zamezite pridavani duplicit a bude vam
 * fungovat prvni sada testu.
 *
 * V tezsi variante je nutno zajistit, aby byl slozeny interval reprezentovan
 * mnozinou disjunktnich intervalu, navic pro metodu toString razeny vzestupne.
 * Disjunktni = neprekryvaji se, pokud se nejake intervaly prekryvaji je nutne
 * je slit dohromady, napr. pri pridavani. Tato varianta musi projit obema sadami
 * testu.
 */
public class SlozenyInterval {
    /*
     * Seznam intervalu.
     * Pouziti LinkedList neni nutne, pouzijte cokoliv se vam zlibi.
     * Ale pomoci LinkedList byla vytvorena referencni implementace.
     */
    protected LinkedList<Interval> intervaly = new LinkedList<Interval>();

    /**
     * Konstruktor
     * @param interval prvni prvek slozeneho intervalu
     */
    public SlozenyInterval(Interval interval) {
        //DOPLNTE
    }

    /**
     * Konstruktor s prvnim prvek intervalu
     * @param zacatek zacatek prvniho prvku
     * @param konec konec prvniho prvku
     */
    public SlozenyInterval(double zacatek, double konec) {
        /* NEMENIT */
        this(new Interval(zacatek, konec));
    }

    /**
     * Konstruktor bez prvniho prvku. V soucasnoti private (muze se vam hodit
     * v nekterych pripadech dalsich operaci, napr. prunik ;-) )
     */
    private SlozenyInterval() {
        /* NEMENIT */
    }

    /**
     * Prida dilci interval do slozeneho intervalu
     * @param zacatek zacatek vkladaneho intervalu
     * @param konec konec vkladaneho intervalu
     */
    public void pridej(double zacatek, double konec) {
        pridej(new Interval(zacatek, konec));
    }

    /**
     * Prida dilci interval do slozeneho intervalu.
     * V zakladni variante postaci eliminace duplicit, tj. do mnoziny
     * nepridavame interval <0,1>, pokud tam uz jeden <0,1> je.
     *
     * V pokrocile variante nejakym zpusobem zajistime sliti dilcich intervalu,
     * pokud se prekryvaji.
     * Napr. pokud pridame
     * <0,1> a <0.5,2>, bude vysledny interval slit dohromady do <0,2>.
     *
     * @param novyInterval vkladany interval
     */
    public void pridej(Interval novyInterval){
        //DOPLNTE
    }

    /**
     * Rozhodne, zdali cislo patri do intervalu
     * @param cislo
     * @return true, pokud cislo do intervalu patri
     */
    public boolean obsahuje(double cislo) {
        //DOPLNTE
    }

    /**
     * Provede sjednoceni dvou slozenych intervalu.
     * Vsimnete si, ze mate operaci pridej pro vkladani a operaci slij
     * u jednoducheho intervalu ...
     * @param b druhy slozeny interval
     * @return vysledek operace sjednoceni
     */
    public SlozenyInterval sjednoceni(SlozenyInterval b) {
        //DOPLNTE
    }

    /**
     * prunik slozeneho intervalu s jednoduchym intervalem. Nezapomente, ze
     * mate prunik implementovan na jednoduchych intervalech
     * @param interval druhy interval
     * @return vysledek operace prunik
     */
    public SlozenyInterval prunik(Interval interval) {
        //DOPLNTE
    }

    /**
     * prunik slozeneho intervalu s druhym slozenym intervalem.
     * Nezapomente, ze o kousek vys mate metodu pro prunik s jednoduchym
     * intervalem.
     * @param interval druhy interval
     * @return vysledek operace prunik
     */
    public SlozenyInterval prunik(SlozenyInterval interval) {
        //DOPLNTE
    }


    /**
     * Konverze na string, aby fungovaly testy, musi se soucasti slozeneho intervalu
     * radit na vystup v vzestupnem poradi, v pripade lehcich testu jen v poradi
     * v jakem byly vlozeny
     * @return
     */
    @Override
    public String toString() {
        //FIXME: pokud to nevyhovuje vasi implementaci, zmente
        String output = "<";
        for (Interval i : intervaly) {
            output += i;
        }
        output += ">";
        return output;
    }

    /**
     * Vrati true pokud je prazdny. Je private, takze uzijete jen pro interni
     * zalezitosti.
     */
    private boolean prazdny() {
        //FIXME: pokud to nevyhovuje vasi implementaci, zmente
        return intervaly.size() == 0;
    }
    
}
